//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1   clrDeepSkyBlue
#property indicator_width1   2
#property strict

//
//
//
//
//

extern int                CovariancePeriod    = 25;          // Covariance period
extern ENUM_APPLIED_PRICE MaPrice             = PRICE_CLOSE; // Ma price
extern ENUM_MA_METHOD     MaType              = MODE_SMA;    // Ma type
extern string             MaSymbol1           = "";          // First symbol
extern string             MaSymbol2           = "";          // Second ma symbol

double val[];
double ma1[];
double ma2[];
string indicatorFile;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   IndicatorDigits(6);
   SetIndexBuffer(0,val);
   SetIndexBuffer(1,ma1);
   SetIndexBuffer(2,ma2);
      if (MaSymbol1=="") MaSymbol1=_Symbol;
      if (MaSymbol2=="") MaSymbol2=_Symbol;
         indicatorFile = WindowExpertName();
         returnBars    = (CovariancePeriod==-99);
      IndicatorShortName("Covariance for : "+MaSymbol1+" to "+MaSymbol2+" ("+(string)CovariancePeriod+")");
   return(0);
}

//
//
//
//
//
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { val[0]=limit; return(0); }
           if (MaSymbol1!=_Symbol) limit = (int)MathMin(Bars-1,MathMax(iCustom(MaSymbol1,0,indicatorFile,-99,0,0),limit));
           if (MaSymbol2!=_Symbol) limit = (int)MathMin(Bars-1,MathMax(iCustom(MaSymbol2,0,indicatorFile,-99,0,0),limit));
           

   //
   //
   //
   //
   //

   for(int i=limit;i>=0;i--)
   {
      ma1[i]  = iMA(MaSymbol1,0,CovariancePeriod,0,MaType,MaPrice,iBarShift(MaSymbol1,0,Time[i]));
      ma2[i]  = iMA(MaSymbol2,0,CovariancePeriod,0,MaType,MaPrice,iBarShift(MaSymbol2,0,Time[i]));
      val[i] = 0;
         for (int k=0; k<CovariancePeriod && (i+k)<Bars; k++)
            val[i] += (iMA(MaSymbol1,0,1,0,MODE_SMA,MaPrice,iBarShift(MaSymbol1,0,Time[i]))-ma1[i])*
                      (iMA(MaSymbol2,0,1,0,MODE_SMA,MaPrice,iBarShift(MaSymbol2,0,Time[i]))-ma2[i]);
      val[i] /= (CovariancePeriod-1);
   }
   return(0);
}